package de.isse.kiv.source

import org.eclipse.core.resources.IFile
import org.eclipse.core.resources.IMarker
import org.eclipse.core.resources.IResource
import org.eclipse.core.runtime.CoreException
import org.eclipse.jface.text.source.IAnnotationHover
import org.eclipse.jface.text.source.ISourceViewer
import org.eclipse.ui.IEditorInput
import org.eclipse.ui.IFileEditorInput
import org.eclipse.ui.texteditor.ITextEditor
import de.isse.kiv.resources.Marker
//remove if not needed
import scala.collection.JavaConversions._

class ErrorHover(editor: ITextEditor) extends IAnnotationHover {

  override def getHoverInfo(sourceViewer: ISourceViewer, lineNumber: Int): String = {
    val input = editor.getEditorInput
    if (!(input.isInstanceOf[IFileEditorInput])) return "File is not opened as a resource"
    val file = input.asInstanceOf[IFileEditorInput].getFile
    try {
      val markers = {
        file.findMarkers(Marker.ERROR_MARKER_ID, true, IResource.DEPTH_INFINITE).toList ++
        file.findMarkers(Marker.WARNING_MARKER_ID, true, IResource.DEPTH_INFINITE).toList
      }
      markers.foreach { marker =>
        val markerLineNumber = marker.getAttribute(IMarker.LINE_NUMBER).asInstanceOf[java.lang.Integer]
        if (markerLineNumber == lineNumber || markerLineNumber == lineNumber + 1) {
          return marker.getAttribute(IMarker.MESSAGE).asInstanceOf[String]
        }
      }
    } catch {
      case e: CoreException => 
    }
    null
  }
}
