package de.isse.kiv.source

import org.eclipse.ui.texteditor.ITextEditor
import org.eclipse.core.resources.IFile
import de.isse.kiv.resources.ResourceProperties._
import de.isse.kiv.resources.ResourceLookup

/**
 * Given an ITextEditor, supply the respective resource, model and spec object.
 * Used in SymbolProcessor, HyperlinkDetector
 */
trait WithSpec {
  def editor: ITextEditor
  def file = ResourceLookup.editedFile(editor)
  def specName = file.specName
  def fileModel = file.fileModel
  def projectModel = file.getProject.projectModel
  def spec = projectModel.getSpec(specName)
  def signatureBefore = projectModel.signatureBefore(file)
  def signatureAfter = projectModel.signatureAfter(file)
}
