package de.isse.kiv.ui

import org.eclipse.ui.IFolderLayout
import org.eclipse.ui.IPageLayout
import org.eclipse.ui.IPerspectiveFactory
import org.eclipse.ui.console.IConsoleConstants
import de.isse.kiv.ui.viewers.SymbolView
import de.isse.kiv.ui.navigator.Navigator

class PerspectiveFactory extends IPerspectiveFactory {

  def createInitialLayout(layout: IPageLayout) {
    layout.addNewWizardShortcut("de.isse.kiv.ui.wizards.newProject")
    val topLeft = layout.createFolder("topLeft", IPageLayout.LEFT, 0.25f, layout.getEditorArea)
    topLeft.addView(Navigator.NAVIGATOR_VIEW_ID)
    topLeft.addPlaceholder(IPageLayout.ID_BOOKMARKS)
    val bottomLeft = layout.createFolder("bottomLeft", IPageLayout.BOTTOM, 0.50f, "topLeft")
    bottomLeft.addView(IPageLayout.ID_OUTLINE)
    bottomLeft.addView(SymbolView.SYMBOL_VIEW_ID)
    val bottom = layout.createFolder("bottom", IPageLayout.BOTTOM, 0.76f, layout.getEditorArea)
    bottom.addView(IPageLayout.ID_PROBLEM_VIEW)
    bottom.addView(IConsoleConstants.ID_CONSOLE_VIEW)
  }
}
