package de.isse.kiv.ui.handlers

import org.eclipse.core.commands.AbstractHandler
import org.eclipse.core.commands.ExecutionEvent
import org.eclipse.jface.text.ITextSelection

import de.isse.kiv.resources.ResourceLookup
import de.isse.kiv.resources.ResourceProperties.toResourceProperties
import de.isse.kiv.refactoring.CodeRenameRefactoring
import de.isse.kiv.source.TokenMap
import de.isse.kiv.ui.wizards.RenameRefactoringWizard
import de.isse.kiv.source.Configuration
import de.isse.kiv.project.Definition

class GotoDefinitionHandler extends AbstractHandler {

  override def execute(event: ExecutionEvent): AnyRef = {
    val editor = ResourceLookup.activeTextEditor
    if (editor == null) return null
    val cursorOffset = editor.getSelectionProvider().getSelection.asInstanceOf[ITextSelection].getOffset
    val file = ResourceLookup.documentResource
    if (file == null) return null
    val fileModel = file.fileModel
    val token = fileModel.tokenAt(cursorOffset).getOrElse(return null)

    Definition.gotoDefinitionAction(file, token).foreach { _() }
    null
  }
}
