package de.isse.kiv.ui.handlers

import org.eclipse.core.commands.AbstractHandler
import org.eclipse.core.commands.ExecutionEvent
import org.eclipse.core.commands.ExecutionException
import org.eclipse.core.resources.IProject
import org.eclipse.core.resources.IResource
import org.eclipse.jface.viewers.ISelection
import org.eclipse.jface.viewers.IStructuredSelection
import org.eclipse.ui.IWorkbenchPage
import de.isse.kiv.KIVPlugin
import de.isse.kiv.resources.ResourceLookup
import de.isse.kiv.KIVSystem
import org.eclipse.core.runtime.jobs.Job
import org.eclipse.core.runtime._

class StartKIVHandler extends AbstractHandler {

  override def execute(event: ExecutionEvent): AnyRef = {
    event.getCommand.getId.toString match {
      case "de.isse.kiv.ui.commands.workon" =>
        val page = ResourceLookup.activePage
      
        page.getSelection match {
          case selection: IStructuredSelection =>
            selection.getFirstElement match {
              case resource: IResource =>
                val project = resource.getProject
                val openJob = new Job(s"Opening project in KIV: ${project.getName}") {
                  override protected def run(monitor: IProgressMonitor): IStatus = {
                    monitor.beginTask("", IProgressMonitor.UNKNOWN)
                    if (! project.isOpen())
                      project.open(monitor)
                    KIVSystem.workon(project)
                    monitor.done()
                    return Status.OK_STATUS;
                  }
                }
                openJob.schedule()
            }
        }
      case "de.isse.kiv.ui.commands.startkiv" =>
        KIVSystem.startkiv()
    }
    null
  }
}
