package de.isse.kiv.ui.viewers

import org.eclipse.jface.action.MenuManager
import org.eclipse.jface.viewers.Viewer
import org.eclipse.jface.action.IMenuListener
import org.eclipse.ui.IWorkbenchPartSite
import org.eclipse.swt.widgets.Menu

object ViewerProperties {
  implicit def toViewerProperties(viewer: Viewer) = new ViewerProperties(viewer)
}

// https://github.com/eclipse/atl/blob/master/deprecated/org.atl.eclipse.adt.editor/src/org/atl/eclipse/adt/ui/outline/AtlContentOutlinePage.java
class ViewerProperties(viewer: Viewer) {
  def createContextMenu(id: String, site: IWorkbenchPartSite /*, listener: IMenuListener */) {
    val manager = new MenuManager()
    manager.setRemoveAllWhenShown(true)
    // manager.addMenuListener(listener)
    
    val control = viewer.getControl
    val menu: Menu = manager.createContextMenu(control)
    control.setMenu(menu)

    if(site != null)
      site.registerContextMenu(id, manager, viewer)
  }
}