package de.isse.kiv.ui.wizards

import java.util.List
import org.eclipse.jface.dialogs.IDialogSettings
import org.eclipse.jface.viewers.IStructuredSelection
import org.eclipse.jface.viewers.StructuredSelection
import org.eclipse.jface.wizard.Wizard
import org.eclipse.ui.IImportWizard
import org.eclipse.ui.IWorkbench
import org.eclipse.ui.ide.IDE
import org.eclipse.ui.internal.WorkbenchPlugin
import org.eclipse.ui.internal.ide.IDEWorkbenchPlugin
import org.eclipse.ui.internal.wizards.datatransfer.DataTransferMessages
import org.eclipse.ui.internal.wizards.datatransfer.WizardArchiveFileResourceImportPage1
import org.eclipse.ui.plugin.AbstractUIPlugin
import de.isse.kiv.ui.Console

class ArchiveWizard extends Wizard with IImportWizard {

  private var workbench: IWorkbench = _

  private var selection: IStructuredSelection = _

  private var mainPage: WizardArchiveFileResourceImportPage1 = _

  val plugin = WorkbenchPlugin.getDefault

  val workbenchSettings = plugin.getDialogSettings

  var section = workbenchSettings.getSection("ZipFileImportWizard")

  if (section == null) {
    section = workbenchSettings.addNewSection("ZipFileImportWizard")
  }

  setDialogSettings(section)

  override def addPages() {
    super.addPages()
    mainPage = new ArchiveWizardPage(workbench, selection, getFileImportMask)
    addPage(mainPage)
  }

  protected def getFileImportMask(): Array[String] = null

  def init(workbench: IWorkbench, currentSelection: IStructuredSelection) {
    this.workbench = workbench
    this.selection = currentSelection
    val selectedResources = IDE.computeSelectedResources(currentSelection)
    if (!selectedResources.isEmpty) {
      //If something was selected in any explorer window, it was not possible to open the ArchiveImportWizard
      //Selection has to be empty!
      //this.selection = new StructuredSelection(selectedResources)
      this.selection = new StructuredSelection();
    }
    setWindowTitle(DataTransferMessages.DataTransfer_importTitle)
    setDefaultPageImageDescriptor(IDEWorkbenchPlugin.getIDEImageDescriptor("wizban/importzip_wiz.png"))
    setNeedsProgressMonitor(true)
  }

  override def performCancel(): Boolean = mainPage.cancel()

  def performFinish(): Boolean = mainPage.finish()

}