package de.isse.kiv.ui.wizards

import org.eclipse.jface.dialogs.Dialog
import org.eclipse.ltk.ui.refactoring.UserInputWizardPage
import org.eclipse.swt.SWT
import org.eclipse.swt.events.ModifyEvent
import org.eclipse.swt.events.ModifyListener
import org.eclipse.swt.events.SelectionEvent
import org.eclipse.swt.events.SelectionListener
import org.eclipse.swt.layout.GridData
import org.eclipse.swt.layout.GridLayout
import org.eclipse.swt.widgets.Button
import org.eclipse.swt.widgets.Composite
import org.eclipse.swt.widgets.Label
import org.eclipse.swt.widgets.Text

import de.isse.kiv.refactoring.CodeExtractRefactoring

class ExtractRefactoringWizardPage(extracttype: Int, name: String, renameWizard: ExtractRefactoringWizard) extends UserInputWizardPage(name: String) {

  var initialized = false
  var nameField: Text = _  
  var returnTypeField: Text = _

  def createControl(parent: Composite): Unit = {

    initializeDialogUnits(parent)
    val composite = new Composite(parent, SWT.NONE)
    setControl(composite)
    val gridLayout = new GridLayout(1, false)
    gridLayout.verticalSpacing = 8
    composite.setLayout(gridLayout)

  }

  override def setVisible(visible: Boolean) {
    if (visible && !initialized) {
      initialized = true
      val composite = getControl.asInstanceOf[Composite]
      createUserInterface(composite)
      Dialog.applyDialogFont(composite)
    }
    super.setVisible(visible)
  }

  def createUserInterface(composite: Composite) {

    val gridData = new GridData(SWT.FILL, SWT.FILL, true, false)

    gridData.verticalIndent = 8
    composite.setLayoutData(gridData)
    val gridLayout2 = new GridLayout(1, false)
    gridLayout2.verticalSpacing = 8
    gridLayout2.marginTop = 3
    composite.setLayout(gridLayout2)

    val label = new Label(composite, SWT.NONE)
    extracttype match {
      case 0 => label.setText("Name of extracted Prozedure:")
      case 1 => label.setText("Name of extracted Predicate:")
      case 2 => label.setText("Name of extracted Function:")
      case 3 => label.setText("No expression or programm found. Refactoring not possible"); return
    }
    nameField = new Text(composite, SWT.SINGLE | SWT.LEFT | SWT.BORDER)
    nameField.setLayoutData(new GridData(GridData.FILL_HORIZONTAL))
    
    val refactorer = renameWizard.getRefactoring.asInstanceOf[CodeExtractRefactoring]
    
    val textFoundExpression = new Label(composite, SWT.NONE)
    textFoundExpression.setText("Found Expression/Programm:\n "+refactorer.selectedString)
    
    if(extracttype == 2) {
      val label2 = new Label(composite, SWT.NONE)
      label2.setText("Returntype of Function:")
      returnTypeField = new Text(composite, SWT.SINGLE | SWT.LEFT | SWT.BORDER)
      returnTypeField.setLayoutData(new GridData(GridData.FILL_HORIZONTAL))
      returnTypeField.setText(refactorer.returntype)
      
      returnTypeField.addModifyListener(new ModifyListener() {

       override def modifyText(event: ModifyEvent) {
        refactorer.returntype = returnTypeField.getText
         }
      })
    }
        
    
    nameField.addModifyListener(new ModifyListener() {

      override def modifyText(event: ModifyEvent) {
        refactorer.editedName = nameField.getText
      }
    })
    
    nameField.setText("Extracted")
    nameField.setFocus()
    nameField.selectAll()

  }

}