package de.isse.kiv.ui.wizards

import org.eclipse.core.resources.IProject
import org.eclipse.core.runtime.CoreException
import org.eclipse.core.runtime.IConfigurationElement
import org.eclipse.core.runtime.IExecutableExtension
import org.eclipse.core.runtime.IPath
import org.eclipse.core.runtime.IProgressMonitor
import org.eclipse.jface.wizard.Wizard
import org.eclipse.ui.INewWizard
import org.eclipse.ui.wizards.newresource.BasicNewProjectResourceWizard
import de.isse.kiv.resources.Import

abstract class KIVProjectWizard extends Wizard with INewWizard with IExecutableExtension {

  private var configElement: IConfigurationElement = _

  override def setInitializationData(config: IConfigurationElement, propertyName: String, data: AnyRef) {
    this.configElement = config
  }

  protected def updatePerspective() {
    if (configElement != null) BasicNewProjectResourceWizard.updatePerspective(configElement)
  }

  protected def createProject(name: String, comment: String, location: IPath, monitor: IProgressMonitor): IProject = {
    val projectBuilder = new Import(name, comment, location, monitor)
    projectBuilder.createProject()
    projectBuilder.project
  }
}
