package de.isse.kiv.ui.wizards

import org.eclipse.core.runtime.CoreException
import org.eclipse.core.runtime.IPath
import org.eclipse.core.runtime.IProgressMonitor
import org.eclipse.jface.viewers.IStructuredSelection
import org.eclipse.ui.IWorkbench

class NewProjectWizard extends KIVProjectWizard() {

  protected var page: NewProjectWizardPage = _

  setNeedsProgressMonitor(true)

  override def addPages() {
    page = new NewProjectWizardPage()
    addPage(page)
  }

  override def init(workbench: IWorkbench, selection: IStructuredSelection) {
  }

  override def performFinish(): Boolean = {
    val monitor: IProgressMonitor = null
    val name = page.getProjectName
    val comment = ""
    val location = page.getProjectLocationPath
    try {
      createProject(name, comment, location, monitor)
    } catch {
      case e: CoreException => return false
    }
    page.dispose()
    updatePerspective()
    true
  }
}
