package de.isse.kiv.ui.wizards

import org.eclipse.core.runtime.NullProgressMonitor
import org.eclipse.ltk.core.refactoring.Refactoring
import org.eclipse.ltk.ui.refactoring.RefactoringWizard

import de.isse.kiv.refactoring.CodeRenameRefactoring

class RenameRefactoringWizard(refactoring: Refactoring) extends RefactoringWizard(refactoring, RefactoringWizard.DIALOG_BASED_USER_INTERFACE | RefactoringWizard.CHECK_INITIAL_CONDITIONS_ON_OPEN) {

  def addUserInputPages() {
    this.addPage(new RenameRefactoringWizardPage("Rename", this))
  }

  override def performFinish(): Boolean = {
    val change = refactoring.asInstanceOf[CodeRenameRefactoring].createChange(new NullProgressMonitor)
    change.perform(new NullProgressMonitor)
    true
  }
}
